================================================================================
SVN $Id: ChangeLog 3627 2007-03-21 18:42:46Z robj $
SVN $URL: https://svn-ccsm-models.cgd.ucar.edu/csm_share/trunk_tags/share3_070321/ChangeLog $
================================================================================

Originator: robj
Date: Wed Mar 21 12:41:06 MDT 2007
Model: share
Version: share3_070321
One-line summary: move cpl_map_readd

Changes made:
 - move cpl_map_readd to mct_mod and rename it mct_sMat_readdnc.
   This can now be called by both sequential and concurrent CCSM.
	
================================================================================

Originator: kauff
Date: Thu Mar 15 11:50:16 MDT 2007
Model: share
Version: share3_070315
One-line summary: bug fixes & optimizations in dshr & shr/mct_mod.F90

Changes made:
- dshr_domain_decomp2d() ~ fix bug in dshr_domain_decomp2d()
- dshr_map_mapDataB ~ optimize wrt matching bundle lists
- dshr_map.F90 ~ add global timing var, dshr_map_setTiming, timing calls in *_mapDataB
- mct_mod.F90 ~ fix bugs that cause ccsm3 compilation failure...
  * add missing/needed routines: mct_send, mct_recv, mct_router, mct_router_init
  * remove public vars with namespace conflicts
    replace...
    -   use shr_kind_mod      ,only: R8 => SHR_KIND_R8 (also IN,CL)
    with...
    +   use shr_kind_mod
    +   integer,parameter,private :: R8 = SHR_KIND_R8 (also IN,CL)
	
================================================================================

Originator: robj
Date: Tue Mar  6 08:44:49 MST 2007
Model: share
Version: share3_070306
One-line summary: use mct_mod in cpl

Changes made:
 - use mct_mod in csm_share/cpl.  Remove cpl_mct_mod
	
================================================================================

Originator: robj
Date: Mon Mar  5 13:57:15 MST 2007
Model: share
Version: share3_070305
One-line summary: add mct_mod

Changes made:
 - seq_mct_mod copied to share and renamed mct_mod
	
================================================================================

Originator: kauff
Date: Fri Mar  2 17:10:57 MST 2007
Model: share
Version: share3_070302
One-line summary: shr_string & dshr_tInterp optimizations 

Changes made:
- optimizations in shr_string_mod.F90
- optimizations in dshr_tInterp.F90
- new routines in dshr to support parallel data models
	
================================================================================

Originator: tcraig
Date: Sun Feb 25 10:05:54 MST 2007	
Model: share
Version: share3_070225
One-line summary:  added npfix4R and made default

Changes made:
cpl/cpl_map_mod.F90 - add npfix4R and set as default
	
================================================================================

Originator: ? erik ?
Date: ?
Model: share
Version: share3_070220
One-line summary:  ? eshr ?

Changes made:
	
================================================================================

Originator: mvertens
Date: Mon Feb 12 11:12:45 MST 2007
Model: share
Version: share3_070212
One-line summary:  introduced new flds directory for sequential fields coupling

Changes made:
added 
flds/seq_fields_indices.F90
flds/default/seq_flds_mod.F90
flds/dust/seq_flds_mod.F90
flds/gensom/seq_flds_mod.F90
	
================================================================================

Originator: jwolfe
Date: Thu Feb  8 14:43:53 MST 2007
Model: share
Version: share3_070208
One-line summary:  fix bug in shr_jlcp.c (Bugzilla #371)

Changes made:
- shr_jlcp.c - fix a bug by appending a NULL char to the destination filename
               string

================================================================================

Originator: erik
Date: Tue Feb  6 14:25:33 MST 2007
Model: share
Version: share3_070206
One-line summary:  Add eshr_timeMgr_curTimeLEstopTime method

Changes made:
- eshr/eshr_timemgr_mod.F90 -- add new method tweak init slightly

These changes were moved over for CAM from the ...

  https://svn-ccsm-models.cgd.ucar.edu/csm_share/branch_tags/scmshr_tags/scmshr02/

Branch.

================================================================================

Originator: tcraig
Date: Thu Jan 25 16:37:05 EST 2007
Model: share
Version: share3_070126
One-line summary:  implement low memory map weights read

Changes made:
- cpl_map_mod.F90 - add low memory map read (cpl_map_readd)
- cpl_mct_mod.F90 - add a few new mct routines to our list

================================================================================

Originator: kauff
Date: Wed Jan 17 15:38:10 MST 2007
Model: share
Version: share3_070117
One-line summary:  SHR_CONST_TKFRZ = 273.15_R8

Changes made:
- shr_const_mod.F90 - SHR_CONST_TKFRZ = 273.15_R8 (bugz #224)
- minor formatting cleanup in shr_inputinfo wrt tabs & protex comments only

================================================================================

Originator: mvertens
Date: Mon Jan  1 15:12:49 MST 2007
Model: share
Version: share3_070101
One-line summary:  update shr_infputinfo_mod

Changes made:
- update shr_inputinfo_mod to changes put in by John Truesday in cam3_3_43
  in order to have new single column changes work correctly

================================================================================

Originator: tcraig
Date: Tue Dec 19 16:41:01 MST 2006
Model: share
Version: share3_061220
One-line summary:  update shr_jlcp 

Changes made:
- update shr_jlcp for bug fix

================================================================================

Originator: kauff
Date: Tue Dec 19 10:58:34 MST 2006
Model: share
Version: share3_061219
One-line summary:  remove cpp HIDE_MPI if-defs

Changes made:
- remove cpp HIDE_MPI if-defs
- minor formatting cleanup in a few files, mostly wrt tabs & protex comments

================================================================================

Originator: kauff
Date: Wed Nov 15 16:19:38 MST 2006
Model: share
Version: share3_061115
One-line summary:  new shr/shr_flux_mod.F90

Changes made:
- shr_string_mod.F90 ~ make use of F90 back arg/option in index function
- shr_file_mod.F90 ~ shr_file_get() no longer uses system cp if remote file = local file
- shr_file_mod.F90 ~ formatting consistency cleanup
- shr_mpi_mod.F90 ~ new shr_mpi_sendr3/recvr3 needed by parallel dx7 models
- cpl_iobin_mod.F90 ~ fix bug wrt non-root processes closing a file unit when only
  the root pid opened it, see cpl_iobin_open/close(unit)

================================================================================

Originator: kauff
Date: Thu Nov  9 19:43:30 MST 2006
Model: share
Version: share3_061109
One-line summary:  new shr/shr_flux_mod.F90

Changes made:
- new: shr_flux_mod.F90 ~ migrate cpl6 atm/ocn flux calc to here
  related mods in shr_const_mod.F90 & cpl_const_mod.F90
- shr_flux_mod.F90 ~ new, optional output fields: ustar_sv ,re_sv ,ssq_sv
- dshr_rest.F90: set local rpointer file name is same as tail of nml rpointer name

================================================================================

Originator: tcraig
Date: Tue Oct 24 20:11:41 EDT 2006
Model: share
Version: share3_061024
One-line summary:  mods for jaguar

Changes made:
- add shr/shr_jlcp.c to support cp system call from executable on jaguar
- mods to shr/shr_file_mod.F90 to support on jaguar
- mods to shr/shr_sys_mod.F90 to support system and sleep on jaguar

================================================================================

Originator: kauff
Date: Mon Oct 16 16:31:04 MDT 2006
Model: share
Version: share3_061016
One-line summary:  revert to old value: SHR_CONST_TKFRZ = 273.16_R8

Changes made:
- undo tkfrz change in last tag, go back to SHR_CONST_TKFRZ = 273.16_R8 (bugz #224)

================================================================================

Originator: kauff
Date: Thu Oct 12 14:21:24 MDT 2006
Model: share
Version: share3_061012
One-line summary:  SHR_CONST_TKFRZ = 273.15_R8, add Cray cdir/nodep

Changes made:
- shr_const_mod.F90 - SHR_CONST_TKFRZ = 273.15_R8 (bugz #224)
- shr_mpi_mod.F90 - new mpi bcast wrappers for 2d & 3d real arrays
- dshr_dataIn.F90 - now will copy old UB into new LB, if possible
- dshr_bundle.F90, dshr_tInterp.F90 - Cray cdir/nodep vector directives (bugz #109)

================================================================================

Originator: kauff
Date: Thu Sep 21 16:33:19 MDT 2006
Model: share
Version: share3_060921
One-line summary: cpl_comm_mod.F90 ~ new if-def for SPMD mode

Changes made:
- cpl_comm_mod.F90: new if-def'd call to mph_ for SPMD mode: comm = mph_*

================================================================================

Originator: kauff
Date: Fri Sep 15 10:00:55 MDT 2006
Model: share
Version: share3_060915
One-line summary: 

Changes made:
- reduce CX string length SHR_KIND_CX = 320, CX = 2560 caused simulation 
   slowdown (due to inefficient algorithms in shr_string_mod.F90 ?)

================================================================================

Originator: tcraig, kauff
Date: Mon Aug 31
Model: share
Version: share3_060831
One-line summary: 

Changes made:
- Add new version of cpl_map_mod to cpl6, uses sparse matrix plus (bug #202)
- Change domain_compare to differentiate al and oi compares.  Also uses
  eps settings defined in cpl_control_mod (now namelist setable) instead 
  of hardwired.  (bug #191)
- Mods to cpl_fields_getLongName() plus a related change to cpl_iocdf_mod.F90.

================================================================================

Originator: erik
Date: Mon Jul 14
Model: share
Version: share3_060814
One-line summary: 

Changes made:
-Make write(6 before unit 6 open in shr_file_mod write(*
-Remove shr_sys_flush(6) calls until after unit 6 open
-Above needed to work on phoenix

================================================================================

Originator: erik
Date: Wed Jul 9
Model: share
Version: share3_060809
One-line summary: 

Changes made:
-Make eshr_timemgr_clockGetPerpYMD public method.
-Add ability to add offset when getting perpetual date.
-Add test of above to unit test.

================================================================================

Originator: erik
Date: Mon Jul 10 13:22:32 MDT 2006
Model: share
Version: share3_060710
One-line summary: updates to support sequential CCSM driver clocks

Changes made:
-Add shr_inputInfo_mod -- general CCSM input information
-Move shr_msg_mod functionality to shr_file_mod -- make private subroutine to read namelist
-shr_ncio_mod -- read and write of scalar NetCDF data
-Add eshr directory for ESMF functions
-Add eshr_timemgr_mod -- ESMF clock functionality

================================================================================

Originator: kauff
Date: Fri Jun  2 16:17:32 MDT 2006
Model: share
Version: share3_060602
One-line summary: updates to support dlnd7 & dx7 models in general

Changes made:
- new dshr_domain_assignPtr function
- fix minor bug in shr_stream_getNextFileName

================================================================================

Originator: kauff
Date: Thu May 25 16:36:06 MDT 2006
Model: share
Version: share3_060525
One-line summary: updates to support dlnd7 & dx7 models in general

Changes made:

- dshr_domain now has a fraction field (for land fraction)
- dshr_nml    now has new streamr for runoff (for lnd model only)
- shr & dshr use character(CX) for field lists (not CL)
- dshr_dataIn - new logic wrt prefetching data on startup

===============================================================

Originator: tcraig (Tony Craig)
Date: Wed Apr 19 04:27:57 MDT 2006
Model: share
Version: share3_060419
One-line summary: update a few cpl routine for performance on phoenix

Changes made:

- cpl_bundle_mod.F90 update fcopy and use fcopy on phoenix.  seems
  to be faster than mct copy routine right now.  lost of cost in
  string operations.
- cpl_map_mod.F90 remove old npfix routines.  add some save operations
  in npfix3 -> npfix3r (reuse) to reduce cost on phoenix related to
  string operations.

===============================================================

Originator: kauff (Brian Kauffman)
Date: Wed Mar 29 16:50:16 MST 2006
Model: share
Version: share3_060329
One-line summary: fix bug in shr_string_mod.F90

Changes made:

- fix bug in shr_string_mod.F90
- introduce: shr_kind_cx ~ and extra long string type (2560 chars)
- introduce: d/shr_const_tkfrzsw ~ temperature of freezing salt water

===============================================================

Originator: kauff ( Brian Kauffman)
Date: Thu Mar  9 20:10:33 MST 2006
Model: share
Version: share3_060309
One-line summary: add if-def/Cray-only sort routine in cpl_contract

Changes made:

cpl
- add if-def/Cray-only sort routine in cpl_contract_mod.F90
- add shr_timers to cpl_contract_decomp()

===============================================================

Originator: kauff ( Brian Kauffman)
Date: Fri Feb 10 11:54:25 MST 2006
Model: share
Version: share3_060210
One-line summary: switch to SVN keywords, various minor fixes

Changes made:

shr
- CVS keywords changed to SVN keywords
- align shr_timer code with ccsm3.0.1 release code
- introduce local R8 kind in shr_const for readability
dshr
- CVS keywords changed to SVN keywords
- added new dshr_const_pstd needed by datm7-CLMNCEP
- dshr_bundle_assignPtr routines set pointers to NULL() on error
- new dshr_nml branch files names for buns & streams to support
  dx7 branching (dx7 branching not functional yet)
cpl
- CVS keywords changed to SVN keywords
- bug fix to cpl6 netCDF history attribute names

===============================================================

Originator: kauff ( Brian Kauffman)
Date: Mon Dec  5 18:23:29 MST 2005
Model: SHARE
Version: SHARE3.051205
One-line summary: new support for docn7 and dx7 restart functionality in general

Changes made:

o new shr & dshr constants for docn7
o shr_stream pre-fetches new and removes old files
o dshr_domain_compare aborts if either domain is not filled
o dshr_rest_readPointer _readBundle _readStream are 3 routines (not one)
o shr_stream_getPrevFileName _getNextFileName support pre-fetching
  and removing old files
o shr_stream_restWrite _restRead fully functional
o new: shr_sys_iounit  finds unused f90 unit number

===============================================================
===============================================================

Originator: kauff ( Brian Kauffman)
Date: Wed Nov 23 16:27:09 MST 2005
Model: SHARE
Version: SHARE3.051123
One-line summary: new dshr & shr_stream restart functionality

Changes made:
o shr_stream restart functionality
o sshr_rest uses shr_stream restart functionality
o dshr_dataIn pre-fetch and rm old file functionality
o shr_sys_ioUnit  returns unused fortran unit number

===============================================================
===============================================================

Originator: jeff ( Yen-Huei Lee)
Date: Sat Nov 19 12:19:14 MST 2005
Model: SHARE
Version: SHARE3.051119
One-line summary: share3_051119 
						
Changes made:

add cpl_fields_mod.F90.CO2C
===============================================================
===============================================================

Originator: kauff ( Brian Kauffman)
Date: Fri Nov  4 17:06:29 MST 2005
Model: SHARE
Version: SHARE3.051104
One-line summary: share3_051104 
						
Changes made:
o remove stat=rc arg from deallocs in shr_map_set
  because this recently began causing seg-faults on bluesky
o added vector nml variable to dshr_nml.F90
o added dshr_bundle_copyFields routine
o formatting cleanup of dshr_bundle.F90
o more robust shr_string_listIsValid

===============================================================
===============================================================

Originator: mvertens ( Mariana Vertenstein)
Date: Tue Oct 25 12:37:13 MDT 2005
Model: SHARE
Version: SHARE3.051025
One-line summary: made changes to remove necessityty for autopromotion
Changes made:
	
Tom Henderson's tool "addrealkind" was used to change "real"
declarations to 
  cpl/dshr : change "real" to "real(R8)" and to add "_R8" 
	to all floating point constants that were not already typed. 
  shr : change "real" to "real(SHR_KIND_R8)" and to add "SHR_KIND_R8" 
	to all floating point constants that were not already typed. 

  float(iii) and real(iii) were replaced by real(iii,r8).
===============================================================
===============================================================

Originator: tcraig ( Anthony Craig)
Date: Sun Oct 16 13:56:26 MDT 2005
Model: SHARE
Version: SHARE3.051016
One-line summary: Bug fixes, fixes datm7 on 
						tempest
Changes made:

fix memory leak in dshr_map
fix use of optional argument in dshr_dataIn

===============================================================
===============================================================

Originator: tcraig ( Anthony Craig)
Date: Thu Oct  6 20:47:19 MDT 2005
Model: SHARE
Version: SHARE3.051006
One-line summary: update csm_share to 
						remove special land grid 
						initialization
Changes made:
 - add frac to list of grid initialization fields (cpl-fields_grid_total
   now 8 fields)
 - clean up contract_init, add frac packing/unpacking, delete dead code.
 - initialize mask and frac to zero rather than spval for all grid cells
   of a domain.
 - add Sx_lfrac to cpl_fields_c2a_states
 - remove cpl_fields_ibuf_inimask variable
 - remove all references to cpl_fields_c2lg_fields and associated
   variables
 - modified all cpl_fields_mod files as needed (not all are tested)
 - add method, cpl_interface_contractField to return the field
   name for a given index.  cpl_interface_contractIndex already
   existed to return an index for a given field.
 - merge bgc23 code into csm_share, UNICOSMP #if in shr_timer_mod
   to handle broken irtc on X1.  added manually.
 - merge bgc23 code, SHR_CONST_PDB, manually.
 - modify code in shr_map_mod to handle SGI runtime error requesting
   size of an array that hasn't yet been allocated.
 - add optional arguments fracName and frac to shr_ncread_domain
   (untested).
 - fix some SGI compile problems with subroutine arguments that have
   both pointer and intent defined, remove intent.
 - remove dshr_hubInfo_iBuf_iniMask variable.
	
===============================================================
===============================================================

Originator: kauff ( Brian Kauffman)
Date: Fri Sep 30 16:41:14 MDT 2005
Model: SHARE
Version: SHARE3.050930
One-line summary: msic minor bug fixes as a result of datm7 development
Changes made:
  1) cpp #ifdef error corrected in shr_sys_mod wrt UNICOSMP
  2) new routine: dshr_hubInfo_init()
  3) fixed stdout type in dshr_domain.F90
===============================================================
===============================================================

Originator: kauff ( Brian Kauffman)
Date: Fri Sep  9 16:00:31 MDT 2005
Model: SHARE
Version: SHARE3.050909
One-line summary: bug fixes in shr/ code wrt non-standard f90 code 
   that worked on bluesky (iIBM) but not tempest (SGI)
Changes made:

1) shr_string_mod.F90 ~ backslash is not a valid f90 continuation line indicator
2) shr_map_mod.F90 ~ allocatable attribute not allowed in derived type (but pointer is OK)
3) shr_stream_mod.F90 ~ minor/cosmetic bug in stdout message wrt domain var names
===============================================================
===============================================================

Originator: tcraig ( Anthony Craig)
Date: Sun Aug 14 06:14:57 MDT 2005
Model: SHARE
Version: SHARE3.050814a
One-line summary: share3_050814a 
						
Changes made:

tag cpl_control_mod.F90, lost in tagging
===============================================================
===============================================================

Originator: tcraig ( Anthony Craig)
Date: Sat Aug 13 17:02:38 MDT 2005
Model: SHARE
Version: SHARE3.050813b
One-line summary: share3_050813b 
						
Changes made:

Merge of share3_050121_brnchT_datm7_050811 onto trunk, done manually
===============================================================
===============================================================

Originator: tcraig ( Anthony Craig)
Date: Sat Aug 13 15:44:00 MDT 2005
Model: SHARE
Version: SHARE3.050813a
One-line summary: Merge of trunk with 
						share3_050121_brnchT_bgc01_050726 onto trunk
Changes made:

Merge of share3_050121_brnchT_bgc01_050726 onto trunk
===============================================================
===============================================================

Originator: tcraig ( Anthony Craig)
Date: Sat Aug 13 15:07:41 MDT 2005
Model: SHARE
Version: SHARE3.050623
One-line summary: Tag head with bug fix in 
						cpl_map memory allocation
Changes made:

tag with bug fix in cpl_map memory allocation, committed in June 2005, never tagged.
===============================================================
===============================================================

Originator: kauff ( Brian Kauffman)
Date: Fri Jan 21 16:57:39 MST 2005
Model: SHARE
Version: SHARE3.050121
One-line summary: new !DIR$ Cray X1 
						directives as per port to 
						Cray at ORNL
Changes made:

new !DIR$ Cray X1 directives as per port to Cray at ORNL
===============================================================
===============================================================

Originator: kauff ( Brian Kauffman)
Date: Fri Jan 21 16:52:12 MST 2005
Model: SHARE
Version: SHARE3.040524
One-line summary: updates to share/cpl code 
						wrt pro-tex comments 
						only
Changes made:

updates to share/cpl wrt pro-tex comments only, done by robj in June 2004
===============================================================
===============================================================

Originator: kauff ( Brian Kauffman)
Date: Sun May 23 19:31:59 MDT 2004
Model: SHARE
Version: SHARE3.040523
One-line summary: share3_040523 
						
Changes made:

Added new routine: cpl/cpl_domain_compare(dom1,dom2)
===============================================================
===============================================================

Originator: kauff ( Brian Kauffman)
Date: Fri May 14 11:15:22 MDT 2004
Model: SHARE
Version: SHARE3.040514
One-line summary: fixed memory leaks in 
						share/cpl
Changes made:

fixed memory leaks in shr/cpl wrt cleaning up MCT strings
===============================================================
===============================================================

Originator: tcraig ( Anthony Craig)
Date: Fri Apr 16 17:14:45 MDT 2004
Model: SHARE
Version: SHARE3.0.7
One-line summary: Add checking of valid 
						decomp_* in cpl
Changes made:

cpl_control_mod, Allow only decomp_al, oi, r to be 1.

===============================================================
===============================================================

Originator: tcraig ( Anthony Craig)
Date: Thu Apr 15 14:25:02 MDT 2004
Model: SHARE
Version: SHARE3.0.6
One-line summary: Add bfb capability for 
						coupler, bfbflag in 
						coupler namelist
Changes made:

cpl_control_mod - add bfbflag namelist/control
cpl_map_mod     - use "src" mapping if bfbflag is true
cpl_bundle_mod  - bfb bundle_gsum option

===============================================================
===============================================================

Originator: kauff ( Brian Kauffman)
Date: Fri Apr  2 10:18:26 MST 2004
Model: SHARE
Version: SHARE3.0.5
One-line summary: 64 bit cpl hist files, 
						new shr_msg_mod 
						routines
Changes made:
cpl: new 64 bit hist file functionality (wrt regression tests)
shr: new routines in shr_msg_mod

===============================================================
===============================================================

Originator: tcraig ( Anthony Craig)
Date: Fri Jan  9 10:01:09 MST 2004
Model: SHARE
Version: SHARE3.0.4
One-line summary: Minor mod for fcopy on 
						vector machines, 
						bfb
Changes made:

Added fcopy_loc in cpl_bundle_copy in cpl_bundle_mod

#ifdef CPP_VECTOR
   fcopy_loc = .false.
   usevector = .true.
#else

===============================================================
===============================================================

Originator: tcraig ( Anthony Craig)
Date: Fri Jan  2 19:12:02 MST 2004
Model: SHARE
Version: SHARE3.0.3
One-line summary: Minor change for compiler 
						problem on ES in 
						cpl_mct_mod.F90
Changes made:

added lines
!  This was added specifically for ES compiler bug:
   public :: cpl_mct_list, cpl_mct_gsmap, cpl_mct_router

Should have no impact on any other platform, tested on IBM.
	
===============================================================
===============================================================

Originator: tcraig ( Anthony Craig)
Date: Fri Dec 12 09:40:04 MST 2003
Model: SHARE
Version: SHARE3.0.2
One-line summary: share3_0_2 
						
Changes made:

Add CDIR mod to cpl_bundle_mod.F90 for ES compiler problem
!CDIR NOASSOC in cpl_bundle_gsum
===============================================================
===============================================================

Originator: tcraig ( Anthony Craig)
Date: Fri Nov 21 17:28:10 MST 2003
Model: SHARE
Version: SHARE3.0.1
One-line summary: Step 2 of merge of 
						share2_1_3_brnchT_cpl6_b031118 to main trunk, share2_1_4
Changes made:

Merge share2_1_3_brnchT_cpl6_b031118 to main trunk, share2_1_4.

===============================================================
===============================================================

Originator: tcraig ( Anthony Craig)
Date: Fri Nov 21 17:20:07 MST 2003
Model: SHARE
Version: SHARE3.0.0
One-line summary: share3_0_0 
						
Changes made:

Merge share2_1_3_brnchT_cpl6_b031118 to main trunk, share2_1_4.

===============================================================
===============================================================

Originator: tcraig ( Anthony Craig)
Date: Fri Nov 21 09:22:34 MST 2003
Model: SHARE
Version: SHARE2.1.4
One-line summary: Tag for merge of 
						cam2_0_2_dev49 version 
						onto main trunk, from 
						share2_1_3
Changes made:

Merge cam2_0_2_dev49 branch changes onto main trunk.
share2_1_3 was starting point.
Added shr_vmath_rsqrt, shr_vmath_div to main trunk.
No other changes.

===============================================================
===============================================================

Originator: tcraig ( Anthony Craig)
Date: Fri May 24 09:34:21 MDT 2002
Model: SHARE
Version: SHARE2.1.3
One-line summary: Tag the latest version of 
						csm_share, share2_1_3 == 
						share2_1_2_brnchT_const9
Changes made:
All mods made on share2_1_2_brnch_const
This version is a merge of share2_1_2_brnchT_const9 onto main trunk
Updated shr_const_mod for new consistent constants
Split shr_msg_stdio to shr_msg_chdir and shr_msg_dirio in shr_msg_mod
Minor mod in shr_msg_orb to use share constant PI
Minor mod in shr_sys_mod to correct format problem and save of 2 variables

===============================================================
===============================================================

Originator: kauff ( Brian Kauffman)
Date: Mon Oct 15 16:45:03 MDT 2001
Model: SHARE
Version: SHARE2.1.2
One-line summary: new shr_vmath_mod.F90
Changes made:
o new shr_vmath module, uniform API to vendor's vector math routines
===============================================================
===============================================================

Originator: rosinski ( Jim Rosinski)
Date: Sun Sep 16 16:17:31 MDT 2001
Model: SHARE
Version: SHARE2.1.1
One-line summary: Changed Linux and SunOS to LINUX and SUNOS
Changes made:

o Changed Linux and SunOS to LINUX and SUNOS
===============================================================

Originator: erik ( Erik Kluzek)
Date: Fri Jun  1 12:28:29 MDT 2001
Model: SHARE
Version: SHARE2.1
One-line summary: Add asynchronous messaging option, make 
   modules public/private, add unit tests, add more platforms
Changes made:

shr_msg_mod has an asynchronous messaging option. 

Make all modules more careful about declaring data and methods 
public or private. In general try to make all modules private 
with explicit declarations on public data and methods. shr_msg_mod 
is still public as it includes "mpif.h" which is assumed to be 
included by most other models.

Add "unit_testers" directory with a few useful unit tests.

Allow shr_sys_mod to work on more platforms: SunOS, and Linux.

===============================================================
===============================================================

Originator: erik ( Erik Kluzek)
Date:   2000/12/21 17:53:15
Model: SHARE
Version: SHARE2.0.6
One-line summary: Change case of kind parameters, add OSF capability.
Changes made:

 Tony upgraded the share library for the Compaq. 

 "convert isend to send in shr_msg_mod.F90
 add OSF (compaq) system calls to shr_sys_mod.F90 and shr_timer_mod.F90"

 Change case of kind parameters to upper-case. This seemed to be an 
 issue on the SGI. I don't think case-sensitivity is in the FORTRAN standard, 
 but the parameters are addressed as upper-case, and it certainly shouldn't 
 hurt anything.

===============================================================
===============================================================

Originator: tcraig ( Anthony Craig)
Date: 2000/12/15 19:12:57
Model: SHARE
Version: SHARE2.0.5
One-line summary: Add dud component.
Changes made:

Add the dud component to the message interface.
===============================================================
===============================================================

Originator: erik ( Erik Kluzek)
Date: Tue Aug 15 08:26:25 MDT 2000
Model: SHARE
Version: SHARE2.0.4
One-line summary: Add HIDE_SHR_MSG back in.
Changes made:

Add HIDE_SHR_MSG token back in shr_msg_mod.F90, so that the
stand-alone CCM would work again. Ran simple CSM test case to
make sure it still works in coupled mode.
===============================================================
===============================================================

Originator: kauff ( Brian Kauffman)
Date: Fri Aug  4 15:25:08 MDT 2000
Model: SHARE
Version: SHARE2.0.3
One-line summary: mpi_isend's replace 
						mpi_sends to insure 
						asynchronous data 
						transfer
Changes made:
mpi_isend's replace mpi_send's to insure asynchronous data transfer


===============================================================
===============================================================

Originator: kauff ( Brian Kauffman)
Date: Fri Jun 23 16:54:23 MDT 2000
Model: SHARE
Version: SHARE2.0.2
One-line summary: Same as 2.0.1 except 
						addition of shr_timer_mod.F90
Changes made:
No changes, except addition of a new file: shr_timer_mod.F90

===============================================================
===============================================================

Originator: kauff ( Brian Kauffman)
Date: Thu Jun  1 15:54:23 MDT 2000
Model: SHARE
Version: SHARE2.0.1
One-line summary: o incremental upgrade
Changes made:

... to shr_file_mod.F90 only, minor fixes to msrcp mss: options
===============================================================
===============================================================

Originator: erik ( KLUZEK ERIK 1326 ML CGD)
Date: Thu May 11 23:34:42 MDT 2000
Model: SHARE
Version: SHARE2.0
One-line summary: Change names to comply with "shr_" convention / add new files
Changes made:

	Change API to agree with convention that all subroutines start with
"shr_" (as well as constants with SHR_. Also move "msg_mod.F90" to 
"shr_msg_mod.F90".

	Add new files for file-archive and constants.

===============================================================
===============================================================

Originator: kauff ( Brian Kauffman)
Date: Fri Oct 16 12:38:16 MDT 1998
Model: SHARE
Version: SHARE1.3.2
One-line summary: more robust: error 
						checking, CVS keywords, 
						info msgs, pxf-routines, 
						etc
Changes made:

===============================================================
===============================================================

Originator: mvertens ( VERTENSTEIN MARIANA 1349 ML CGD)
Date: Thu Oct  1 12:23:29 MDT 1998
Model: SHARE
Version: SHARE1.3.1
One-line summary: made code compatible with standard MPI library
Changes made:
	
Added routine mpi_setup.F
Changed all write(* to write(6 etc.
	
===============================================================
===============================================================

Originator: erik ( Erik Kluzek)
Date: Wed Jul 29 14:32:20 MDT 1998
Model: SHARE
Version: SHARE1.3
One-line summary: Version of csm_share used with CCM3.6, LSM1.1 and CSM1.2
Changes made:

This is the version of CSM_SHARE publically released with CSM1.2.
It is compatable with CCM3.6, LSM1.1, and CPL4.0.

===============================================================
===============================================================

Originator: erik ( Erik Kluzek)
Date: Mon Jul  6 14:31:38 MDT 1998
Model: SHARE
Version: SHARE1.2.2
One-line summary: Delete repeated definition.
Changes made:

	Delete repeated definition that caused trouble with the 
compiler on the SGI.

===============================================================
===============================================================

Originator: erik ( Erik Kluzek)
Date: Tue Jun  9 13:58:13 MDT 1998
Model: SHARE
Version: SHARE1.2.1
One-line summary: Add print flag as argument to orb_params / 
	add a spare coupler compatiblity message #'s
Changes made:

	Added a argument to orb_params to determine if you want
to print messages out or not.  Normally this should be set to
true, but if you are running a program under SPMD you will want
the master to set it to true and the slaves set it to false.
Otherwise, all the processesors print out the same messages.

	Added a list of coupler compatibility message numbers.
that are set and can be used as the coupler changes.  These 
values can not be changed at this point!

===============================================================
===============================================================

Originator: erik ( Erik Kluzek)
Date: Sat Apr 25 20:01:57 MDT 1998
Model: SHARE
Version: SHARE1.2
One-line summary: Require orbital parameters to be set -- don't choose any 
	defaults.
Changes made:

	Change orbit so that either IYEAR_AD or (ECCEN,OBLIQ,MVELP) has
to be set rather than specifying defaults. This makes it much more clear
what the orbital parameters are set to, since the user HAS to enter it
as a required namelist item.  If the parameters aren't set, a long message
comes up that displays what possible values might be.

===============================================================
===============================================================

Originator: erik ( Erik Kluzek)
Date: Tue Apr  7 10:23:02 MDT 1998
Model: SHARE
Version: SHARE1.1
One-line summary: Let 1950 orbit be the default (similar to CCM3.0)
Changes made:

	Set the default orbital parameters to the values that
would be set if you set IYEAR_AD = 1950.  Also change the 
printout so that the parameters are output to full precision.

===============================================================
===============================================================

Originator: erik ( Erik Kluzek)
Date: Wed Apr  1 09:21:10 MST 1998
Model: SHARE
Version: SHARE1.0.3
One-line summary: Changed directory structure to be reduced 
	to 2 -- csm_share and "msg"
Changes made:

	Simply moved files around to accomidate a new directory 
structure.  MPI/msg_wrapper.F was moved to msg/mpi_msg_wrapper.F.
Other files were moved from "orbit" into the main directory.  So
now there are only two directories -- the main "csm_share" directory
and the one sub-directory "msg" for the files dealing with the 
message passing interface.

===============================================================
===============================================================

Originator: erik ( Erik Kluzek)
Date: Mon Jan 26 08:47:09 MST 1998
Model: SHARE
Version: SHARE1.0.2
One-line summary: Moved files to subdirectories, added msgid for cpl, 
		added receive for char.
Changes made:

o Moved files to subdirectories.  

	By doing this we can easily pick which set
of functions each model needs to share, and we can swap out different packages.
For example, we can easily pick a different message passing library by 
compiling the interface routine in the PVM sub-directory for example.  Also
we can place functions dealing with non-NCAR machines here and only add them
in the list to compile if we are at a non-NCAR site.

Subdirectories:
	msg ----- generic message passing files (non-library dependent)
	orbit --- subroutines dealing with the earths orbit. Solar declination,
			Solar zenith angle, and eath-sun distance factor.
	MPI ----- subroutines interfacing to the MPI message passing library.

Updated the README file to document the above changes.  Also suggest names
for other sub-directories to add later (constants, MSS etc.).

o Added a task identifier for the coupler in msgid.h: MSGID_TID_CPL

o Added the character receive function to the MPI msg_wrapper.F (msg_recv_c).

===============================================================
===============================================================

Originator: kauff ( Brian Kauffman)
Date: Thu Jan  8 16:33:25 MST 1998
Model: SHARE
Version: SHARE1.0.1
One-line summary: o shared code with uniform prefix coding style
Changes made:

o all shared code now conforms to the desired coding style,
  namely that all related file, subroutine, variable, common-block
  names, etc, have a uniform prefix.

===============================================================
===============================================================

Originator: erik ( Erik Kluzek)
Date: Tue Dec 16 11:47:11 MST 1997
Model: SHARE
Version: SHARE1.0
One-line summary: Initial version, orbit and message compatability.
Changes made:

Initial version of the shared CSM library.

The purpose of this library is to archive all the code used by CSM models
THAT HAS TO BE THE SAME!  This way we have one location to look for code
that is shared.  So the earth's orbital parameters, and message passing
type codes are archived here.  Other codes regarding the calender and
physical constants could also be put here as well.  This helps to ensure
that models have the same expressions for functions shared across the board.
It is also a more efficient programming paradigm.  And finally it makes it
easier for other models to link into CSM, since all of the interface
requirements are packaged up into one location.

Currently the codes that are here are in three classes...

Orbit:

	Orbital codes to calculate earths' orbital parameters and get solar
	declination angle, earth-sun distance factor, and cosine of the solar 
	zenith angle.

Message Compatability:

	These codes check the messages from the coupler and ensure that the
	version of the coupler messages is compatable with the version
	that is expected.

README/ChangeLog/ChangeSum:

	The README file gives some background on why we created this module
	and how we want/need to manage it.

	ChangeLog gives a long description of changes made.

	ChangeSum is a one-line description of changes made.

At this point only the atmosphere and land components are accessing these
codes, but later all models will use all or part of the codes shared here.
===============================================================
